if isempty(who('redo')), redo=2; end;
if isempty(who('showresults')), showresults=1; end;

DD = 2;
KK = 30;
FF = 1;
nn = 10;
dd = 2;
noise=.03;

if redo>1,
  [XX cc] = trefoilpatch(.1,1,3,.1,1);
  XX=XX+noise*randn(size(XX));
  NN = size(XX,2);
  [LX,MX,PX,Pi]=mppca(XX,FF,KK,1e-10,200,1e-3);
  redo=1;
end;

if redo>0,
  [RR,ZZ] = infermfa(XX,LX,MX,PX,Pi);
  neighbor = knn(XX,nn);
  redo=0;
end;

[YY LY MY] = llc(XX,neighbor,dd,RR,ZZ);

if showresults==1,
  figure(1);
  subplot(121);
  plot3(XX(1,:),XX(2,:),XX(3,:),'r.','MarkerSize',.5);
  plotmfa3(LX,MX,PX);

  subplot(122);
  plot(YY(1,:),YY(2,:),'.');
  plotmfa2(LY,MY,1e-3*[1;1]);
end;
