% xx = lley2x(XX,YY,yy)
%
%   Given global coordinates yy, find high-dim data point xx whose
%   corresponding global coordinates are closest to yy.
%
%   XX and YY are just the training dataset and corresponding global
%   global coordinates.

function xx = lley2x(XX,YY,yy);

[dd NN] = size(YY);

oneNN = ones(1,NN);

dist = sum((YY - yy(:,oneNN)).^2,1);

[mm ind] = min(dist);

xx = XX(:,ind);
