if isempty(who('redo')), redo=2; end;
if isempty(who('showresults')), showresults=1; end;

KK = 20;
x = (0:.2:2*pi)';
n = length(x);
XX = kron(x,ones(n,1));
YY = kron(ones(n,1),x);
XX = [XX YY sin(XX).*sin(YY)]';
cc = XX(3,:)/2+.5;
NN = size(XX,2);
clear x n
XX = XX + .1*randn(size(XX));
FF = 2;
DD = 3;
nn = 12;
dd = 2;

if redo>1,
  [LX,MX,PX,Pi]=mppca(XX,FF,KK,1e-10,200,1e-3);
  redo=1;
end;

if redo>0,
  [RR,ZZ] = infermfa(XX,LX,MX,PX,Pi);
  neighbor = knn(XX,nn);
  redo=0;
end;

[YY LY MY] = llc(XX,neighbor,dd,RR,ZZ);

if showresults==1,
  figure(1);
  fullfig
  scatter3(XX(1,:),XX(2,:),XX(3,:),3,XX(3,:));
  hold on;
  plotmfa3(LX,MX,PX);
  hold off

  figure(2);
  scatter(YY(1,:),YY(2,:),3,XX(3,:));
  hold on
  plotmfa2(LY,MY,[0;0]);
  hold off
end;
