
function [hp,hl] = surfmfa3(LX,MX,Pi,cc);

Pi = diag(Pi);
th = (0:.01:2*pi)';

hh = ishold;
if ~hh, cla; end;
hold on;

for ii=1:size(MX,2),
  ll = LX(:,:,ii);
  uu = MX(:,ii);
  xx = uu(1) + cos(th)*ll(1,1) + sin(th)*ll(1,2);
  yy = uu(2) + cos(th)*ll(2,1) + sin(th)*ll(2,2);
  zz = uu(3) + cos(th)*ll(3,1) + sin(th)*ll(3,2);
  hp(ii) = patch(xx,yy,zz,cc);

  fl=[uu uu+ll(:,1)];
  hl(ii,1) = plot3(fl(1,:),fl(2,:),fl(3,:),'k-','linewidth',1);
  fl=[uu uu+ll(:,2)];
  hl(ii,2) = plot3(fl(1,:),fl(2,:),fl(3,:),'k-','linewidth',1);

end;

if hh, hold on; else hold off; end;
