function rotatecamera(delta);

aa=gca;
cc=get(aa,'cameratarget');
pp=get(aa,'cameraposition');

set(gcf,'doublebuffer','on');
set(gcf,'renderer','painters');
set(aa,'xlim',get(aa,'xlim'));
set(aa,'ylim',get(aa,'xlim'));
set(aa,'zlim',get(aa,'zlim'));
set(aa,'drawmode','fast');
set(aa,'PlotBoxAspectRatio',get(aa,'PlotBoxAspectRatio'))
set(aa,'dataAspectRatio',get(aa,'dataAspectRatio'))
set(aa,'cameraviewangle',get(aa,'cameraviewangle'))
set(aa,'cameratarget',get(aa,'cameratarget'))
axis off
dist=sqrt(pp(1).^2+pp(2).^2);

if nargin==0,
  % determine delta so that it takes 20 seconds per cycle.
  defaulttotaltimepercycle=20;
  tic;
  pp(1) = cc(1)+dist*cos(0);
  pp(2) = cc(2)+dist*sin(0);
  set(aa,'cameraposition',pp);
  drawnow;
  steptime=toc;
  delta = 2*pi*steptime/defaulttotaltimepercycle;
end;
 
theta=0:delta:2*pi;

try
while(1)
  for ii=1:length(theta),
    pp(1) = cc(1)+dist*cos(theta(ii));
    pp(2) = cc(2)+dist*sin(theta(ii));
    set(aa,'cameraposition',pp);
    drawnow;
  end;
end;
catch
end;
